/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// OrderPrice An amount, usually of money, that represents the actual price paid by the Customer for this item or this order
type OrderPrice struct {
	// A narrative that explains in detail the semantics of this order item price.
	Description *string `json:"description,omitempty"`
	// A short descriptive name such as \"Subscription price\".
	Name *string `json:"name,omitempty"`
	// A category that describes the price, such as recurring, discount, allowance, penalty, and so forth
	PriceType *string `json:"priceType,omitempty"`
	// Could be month, week...
	RecurringChargePeriod *string `json:"recurringChargePeriod,omitempty"`
	// Could be minutes, GB...
	UnitOfMeasure *string `json:"unitOfMeasure,omitempty"`
	BillingAccount *BillingAccountRef `json:"billingAccount,omitempty"`
	Price *Price `json:"price,omitempty"`
	// a strucuture used to describe a price alteration
	PriceAlteration *[]PriceAlteration `json:"priceAlteration,omitempty"`
	ProductOfferingPrice *ProductOfferingPriceRef `json:"productOfferingPrice,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewOrderPrice instantiates a new OrderPrice object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrderPrice() *OrderPrice {
	this := OrderPrice{}
	return &this
}

// NewOrderPriceWithDefaults instantiates a new OrderPrice object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrderPriceWithDefaults() *OrderPrice {
	this := OrderPrice{}
	return &this
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *OrderPrice) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *OrderPrice) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *OrderPrice) SetDescription(v string) {
	o.Description = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *OrderPrice) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *OrderPrice) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *OrderPrice) SetName(v string) {
	o.Name = &v
}

// GetPriceType returns the PriceType field value if set, zero value otherwise.
func (o *OrderPrice) GetPriceType() string {
	if o == nil || o.PriceType == nil {
		var ret string
		return ret
	}
	return *o.PriceType
}

// GetPriceTypeOk returns a tuple with the PriceType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetPriceTypeOk() (*string, bool) {
	if o == nil || o.PriceType == nil {
		return nil, false
	}
	return o.PriceType, true
}

// HasPriceType returns a boolean if a field has been set.
func (o *OrderPrice) HasPriceType() bool {
	if o != nil && o.PriceType != nil {
		return true
	}

	return false
}

// SetPriceType gets a reference to the given string and assigns it to the PriceType field.
func (o *OrderPrice) SetPriceType(v string) {
	o.PriceType = &v
}

// GetRecurringChargePeriod returns the RecurringChargePeriod field value if set, zero value otherwise.
func (o *OrderPrice) GetRecurringChargePeriod() string {
	if o == nil || o.RecurringChargePeriod == nil {
		var ret string
		return ret
	}
	return *o.RecurringChargePeriod
}

// GetRecurringChargePeriodOk returns a tuple with the RecurringChargePeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetRecurringChargePeriodOk() (*string, bool) {
	if o == nil || o.RecurringChargePeriod == nil {
		return nil, false
	}
	return o.RecurringChargePeriod, true
}

// HasRecurringChargePeriod returns a boolean if a field has been set.
func (o *OrderPrice) HasRecurringChargePeriod() bool {
	if o != nil && o.RecurringChargePeriod != nil {
		return true
	}

	return false
}

// SetRecurringChargePeriod gets a reference to the given string and assigns it to the RecurringChargePeriod field.
func (o *OrderPrice) SetRecurringChargePeriod(v string) {
	o.RecurringChargePeriod = &v
}

// GetUnitOfMeasure returns the UnitOfMeasure field value if set, zero value otherwise.
func (o *OrderPrice) GetUnitOfMeasure() string {
	if o == nil || o.UnitOfMeasure == nil {
		var ret string
		return ret
	}
	return *o.UnitOfMeasure
}

// GetUnitOfMeasureOk returns a tuple with the UnitOfMeasure field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetUnitOfMeasureOk() (*string, bool) {
	if o == nil || o.UnitOfMeasure == nil {
		return nil, false
	}
	return o.UnitOfMeasure, true
}

// HasUnitOfMeasure returns a boolean if a field has been set.
func (o *OrderPrice) HasUnitOfMeasure() bool {
	if o != nil && o.UnitOfMeasure != nil {
		return true
	}

	return false
}

// SetUnitOfMeasure gets a reference to the given string and assigns it to the UnitOfMeasure field.
func (o *OrderPrice) SetUnitOfMeasure(v string) {
	o.UnitOfMeasure = &v
}

// GetBillingAccount returns the BillingAccount field value if set, zero value otherwise.
func (o *OrderPrice) GetBillingAccount() BillingAccountRef {
	if o == nil || o.BillingAccount == nil {
		var ret BillingAccountRef
		return ret
	}
	return *o.BillingAccount
}

// GetBillingAccountOk returns a tuple with the BillingAccount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetBillingAccountOk() (*BillingAccountRef, bool) {
	if o == nil || o.BillingAccount == nil {
		return nil, false
	}
	return o.BillingAccount, true
}

// HasBillingAccount returns a boolean if a field has been set.
func (o *OrderPrice) HasBillingAccount() bool {
	if o != nil && o.BillingAccount != nil {
		return true
	}

	return false
}

// SetBillingAccount gets a reference to the given BillingAccountRef and assigns it to the BillingAccount field.
func (o *OrderPrice) SetBillingAccount(v BillingAccountRef) {
	o.BillingAccount = &v
}

// GetPrice returns the Price field value if set, zero value otherwise.
func (o *OrderPrice) GetPrice() Price {
	if o == nil || o.Price == nil {
		var ret Price
		return ret
	}
	return *o.Price
}

// GetPriceOk returns a tuple with the Price field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetPriceOk() (*Price, bool) {
	if o == nil || o.Price == nil {
		return nil, false
	}
	return o.Price, true
}

// HasPrice returns a boolean if a field has been set.
func (o *OrderPrice) HasPrice() bool {
	if o != nil && o.Price != nil {
		return true
	}

	return false
}

// SetPrice gets a reference to the given Price and assigns it to the Price field.
func (o *OrderPrice) SetPrice(v Price) {
	o.Price = &v
}

// GetPriceAlteration returns the PriceAlteration field value if set, zero value otherwise.
func (o *OrderPrice) GetPriceAlteration() []PriceAlteration {
	if o == nil || o.PriceAlteration == nil {
		var ret []PriceAlteration
		return ret
	}
	return *o.PriceAlteration
}

// GetPriceAlterationOk returns a tuple with the PriceAlteration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetPriceAlterationOk() (*[]PriceAlteration, bool) {
	if o == nil || o.PriceAlteration == nil {
		return nil, false
	}
	return o.PriceAlteration, true
}

// HasPriceAlteration returns a boolean if a field has been set.
func (o *OrderPrice) HasPriceAlteration() bool {
	if o != nil && o.PriceAlteration != nil {
		return true
	}

	return false
}

// SetPriceAlteration gets a reference to the given []PriceAlteration and assigns it to the PriceAlteration field.
func (o *OrderPrice) SetPriceAlteration(v []PriceAlteration) {
	o.PriceAlteration = &v
}

// GetProductOfferingPrice returns the ProductOfferingPrice field value if set, zero value otherwise.
func (o *OrderPrice) GetProductOfferingPrice() ProductOfferingPriceRef {
	if o == nil || o.ProductOfferingPrice == nil {
		var ret ProductOfferingPriceRef
		return ret
	}
	return *o.ProductOfferingPrice
}

// GetProductOfferingPriceOk returns a tuple with the ProductOfferingPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetProductOfferingPriceOk() (*ProductOfferingPriceRef, bool) {
	if o == nil || o.ProductOfferingPrice == nil {
		return nil, false
	}
	return o.ProductOfferingPrice, true
}

// HasProductOfferingPrice returns a boolean if a field has been set.
func (o *OrderPrice) HasProductOfferingPrice() bool {
	if o != nil && o.ProductOfferingPrice != nil {
		return true
	}

	return false
}

// SetProductOfferingPrice gets a reference to the given ProductOfferingPriceRef and assigns it to the ProductOfferingPrice field.
func (o *OrderPrice) SetProductOfferingPrice(v ProductOfferingPriceRef) {
	o.ProductOfferingPrice = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *OrderPrice) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *OrderPrice) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *OrderPrice) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *OrderPrice) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *OrderPrice) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *OrderPrice) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *OrderPrice) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrderPrice) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *OrderPrice) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *OrderPrice) SetType(v string) {
	o.Type = &v
}

func (o OrderPrice) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.PriceType != nil {
		toSerialize["priceType"] = o.PriceType
	}
	if o.RecurringChargePeriod != nil {
		toSerialize["recurringChargePeriod"] = o.RecurringChargePeriod
	}
	if o.UnitOfMeasure != nil {
		toSerialize["unitOfMeasure"] = o.UnitOfMeasure
	}
	if o.BillingAccount != nil {
		toSerialize["billingAccount"] = o.BillingAccount
	}
	if o.Price != nil {
		toSerialize["price"] = o.Price
	}
	if o.PriceAlteration != nil {
		toSerialize["priceAlteration"] = o.PriceAlteration
	}
	if o.ProductOfferingPrice != nil {
		toSerialize["productOfferingPrice"] = o.ProductOfferingPrice
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableOrderPrice struct {
	value *OrderPrice
	isSet bool
}

func (v NullableOrderPrice) Get() *OrderPrice {
	return v.value
}

func (v *NullableOrderPrice) Set(val *OrderPrice) {
	v.value = val
	v.isSet = true
}

func (v NullableOrderPrice) IsSet() bool {
	return v.isSet
}

func (v *NullableOrderPrice) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrderPrice(val *OrderPrice) *NullableOrderPrice {
	return &NullableOrderPrice{value: val, isSet: true}
}

func (v NullableOrderPrice) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrderPrice) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


